use enum_index_derive::{EnumIndex,IndexEnum};
use strum_macros::EnumString;

#[derive(Debug, Enum String, EnumIndex, IndexEnum)]
pub enum Genera {
    GnDATA,         //0,  An aggregate type that represents a number of attributes related to a particular family.
    GnCOMMAND,      //1,  Used to send commands to components.
    GnEVENT,        //2,  Notify the rest of the system that something has taken place.
    GnERROR,        //3,  Used to notify the system that something has occurred that should not have occurred.
    GnPARAMETER,    //4,  Used to send parameter information.
    GnSTATUS,       //5,  The persistent status of the component during the current power up state of the processing node.
    GnNUMERIC,      //6,  Used primarily for patient vital-signs numeric, but is not limited to representation of other numeric data.
    GnRESERVE_A,    //7,  Reserved
    GnCONFIG,       //8,  Used to contain the configuration data of the components.
    GnRESERVE_B,    //9,  Reserved
    GnRESERVE_C,    //10, Reserved
    GnREQUEST,      //11, Used to request that one component send a message directly to another component.
    GnRESERVE_D,    //12, Reserved
    GnRESERVE_E,    //13, Reserved
    GnRESERVE_F,    //14, Reserved
    GnRESPONSE,     //15, Response
    GnRESERVE_G,    //16, Reserved
    GnSTREAM,       //17, Used for messaging while not requiring an ACK or NAK.
    GnDATAEXT,      //18, An aggregate type that represents a number of attributes related to a particular family, extended to 4 bytes.
    GnANNOTATION,   //19, Used to contain data that provides additional information for another object.
    GnMAX           //20, Used to contain data that provides additional information for another object.
}